function Update(self)
	if self:IsActivated() and self.usedBy == nil then
		self.nearest = 50;
		for actor in MovableMan.Actors do
			self.distance = math.sqrt((actor.Pos.X - self.Pos.X) ^ 2 + (actor.Pos.Y - self.Pos.Y) ^ 2);
			if self.distance < self.nearest then
				self.nearest = self.distance;
				self.usedBy = actor;
			end
		end
		print(self.PresetName .. " WAS THROWN BY: " .. self.usedBy.PresetName);
		self.timer = Timer();
	end
end

function Destroy(self)
	self.someError = 0;
	if self:IsActivated() then
		--if self.timer.ElapsedSimTimeMS < 2500 then
		--	self.someError = 1;
		--	print(self.PresetName .. " WAS DESTROYED BY GUNFIRE");
		--end
		for actor in MovableMan.Actors do
			self.distance = math.sqrt((actor.Pos.X - self.Pos.X) ^ 2 + (actor.Pos.Y - self.Pos.Y) ^ 2);
			if self.distance < 25 then
				self.someError = 1;
				print(self.PresetName .. " MALFUCTIONED, ACTOR TOO CLOSE: " .. actor.PresetName);
			end
		end
		if not MovableMan:IsActor(self.usedBy) then
			self.someError = 1;
			print(self.PresetName .. " MALFUCTIONED, USER WAS KILLED");
		end
		if self.someError == 0 then
			print(self.PresetName .. " IS TELEPORTING " .. self.usedBy.PresetName);
			self.usedBy.Pos.X = self.Pos.X;
			self.usedBy.Pos.Y = self.Pos.Y-20;
			self.usedBy.Vel = self.Vel;
		end
	end
	if not self:IsActivated() or self.someError == 1 then
		self.sparkle = CreateMOPixel("Teleporter Fail Particle 1");
		self.sparkle.Pos = self.Pos;
    	MovableMan:AddParticle(self.sparkle);
		for i = 0, 20 do
			self.sparkle = CreateMOPixel("Teleporter Fail Particle 2");
			self.sparkle.Pos = self.Pos;
			self.sparkle.Vel:SetMagnitude(3+math.random()*4);
			self.sparkle.Vel:RadRotate(math.random()*3.14);
			MovableMan:AddParticle(self.sparkle);
		end
	end
end
