function Create(self)
    print("INFECTION STARTED");
	self.robotsList = { "Dummy", "Dreadnought", "Small MG Turret", "Robot 1", "Robot 2", "Drone", "Medic Drone", "Brain Robot", "Heavy Brain Robot" }; --feel free to edit
	self.incubationPeriod = 1000;
	self.harmPeriod = 80;
	self.airRange = 90;
	if listOfInfected == nil then
		listOfInfected = { };
	end
	for actor in MovableMan.Actors do
		local isRobot = 0;
		for i = 1, #self.robotsList do
			if actor.PresetName == self.robotsList[i] then
				isRobot = 1;
			end
		end
		if isRobot == 0 and (actor.ClassName == "ACrab" or actor.ClassName == "AHuman") then
			local actorInfected = 0;
			for x = 1, #listOfInfected do
				if listOfInfected[x].actor == actor then
					actorInfected = 1;
				end
			end
			if actorInfected == 0 then
				local distance = math.sqrt((actor.Pos.X - self.Pos.X) ^ 2 + (actor.Pos.Y - self.Pos.Y) ^ 2);
				if distance <= self.airRange*2 then
					print(actor.PresetName .. " IS INFECTED");
					listOfInfected[#listOfInfected + 1] = { };
					listOfInfected[#listOfInfected].actor = actor;
					listOfInfected[#listOfInfected].incubation = 1;
					listOfInfected[#listOfInfected].timer = Timer();
					listOfInfected[#listOfInfected].lastHealth = actor.Health;
				end
			end
		end
	end
	if infectionManaged == 1 then
		self:GibThis(); --means just one Infection Origin particle stays in game at any time
	end
	infectionManaged = 1;
end

function Update(self)
	if #listOfInfected == 0 then
		infectionManaged = 0; --if there's no one infected Infection Origin particle dissapears
		self:GibThis();
		print("INFECTION STOPPED");
	end
	local i = 1;
	while i <= #listOfInfected do
		if MovableMan:IsActor(listOfInfected[i].actor) then
			for actor in MovableMan.Actors do
				local isRobot = 0;
				for i = 1, #self.robotsList do
					if actor.PresetName == self.robotsList[i] then
						isRobot = 1;
					end
				end
				if isRobot == 0 and (actor.ClassName == "ACrab" or actor.ClassName == "AHuman") then
					local actorInfected = 0;
					for x = 1, #listOfInfected do
						if listOfInfected[x].actor == actor then
							actorInfected = 1;
						end
					end
					if actorInfected == 0 then
						local distance = math.sqrt((actor.Pos.X - self.Pos.X) ^ 2 + (actor.Pos.Y - self.Pos.Y) ^ 2);
						if distance <= self.airRange then
							print(actor.PresetName .. " IS INFECTED");
							listOfInfected[#listOfInfected + 1] = { };
							listOfInfected[#listOfInfected].actor = actor;
							listOfInfected[#listOfInfected].incubation = 1;
							listOfInfected[#listOfInfected].timer = Timer();
							listOfInfected[#listOfInfected].lastHealth = actor.Health;
						end
					end
				end
			end
			if listOfInfected[i].incubation == 1 and listOfInfected[#listOfInfected].timer:IsPastSimMS(self.incubationPeriod) then
				print(listOfInfected[i].actor.PresetName .. "'s INFECTION STARTS TO SHOW");
				listOfInfected[i].incubation = 0;
				listOfInfected[#listOfInfected].timer = Timer();
			end
			if listOfInfected[i].incubation == 0 and listOfInfected[#listOfInfected].timer:IsPastSimMS(self.harmPeriod) then
				listOfInfected[i].actor.Health = listOfInfected[i].actor.Health - 1;
				listOfInfected[#listOfInfected].timer = Timer();
			end
			if listOfInfected[i].actor.Health == 100 and listOfInfected[#listOfInfected].lastHealth < 100 then
				print(listOfInfected[i].actor.PresetName .. " IS CURED");
				listOfInfected[i] = listOfInfected[#listOfInfected];
				listOfInfected[#listOfInfected] = nil;
				i = i - 1;				
			end
			listOfInfected[#listOfInfected].lastHealth = listOfInfected[i].actor.Health;
			i = i + 1;
		else
			if #listOfInfected > 1 then
				listOfInfected[i] = listOfInfected[#listOfInfected];
				listOfInfected[#listOfInfected] = nil;
			else
				listOfInfected = {};
			end
		end
		self:GibThis();
	end	
--	for infected in MovableMan.Actors do
--		if infected.isInfected == 1 then
--			print(infected.PresetName .. " IS STILL INFECTED");
--			for actor in MovableMan.Actors do
--				local isRobot = 0;
--				for i=1, #self.robotsList do
--					if actor.PresetName == self.robotsList[i] then
--						isRobot = 1;
--					end
--				end
--				if isRobot == 0 and (actor.ClassName == "ACrab" or actor.ClassName == "AHuman") then
--					local distance = math.sqrt((actor.Pos.X - self.Pos.X) ^ 2 + (actor.Pos.Y - self.Pos.Y) ^ 2);
--					if distance <= self.airRange and actor.isInfected ~= 1 then
--						actor.isInfected = 1;
--						actor.isInIncubation = 1;
--						print(actor.PresetName .. " IS INFECTED");
--						actor.infectionTimer = Timer();
--						actor.lastHealth = infected.Health;
--					end
--				end
--			end
--			if infected.isInIncubation == 1 and infected.infectionTimer:IsPastSimMS(self.incubationPeriod) then
--				print(infected.PresetName .. "'s INFECTION STARTS TO SHOW");
--				infected.isInIncubation = 0;
--				infected.infectionTimer = Timer();
--			end
--			if infected.isInIncubation == 0 and infected.infectionTimer:IsPastSimMS(self.harmPeriod) then
--				infected.Health = infected.Health - 1;
--				infected.infectionTimer = Timer();
--			end
--			if infected.Health == 100 and infected.lastHealth < 100 then
--				print(infected.PresetName .. " IS CURED");
--				infected.isInfected = 0;
--			end
--			infected.lastHealth = infected.Health;
--		end
--	end
end
