function Create(self)
    print("INFECTION STARTED");
	self.robotsList = { "Dummy", "Dreadnought", "Small MG Turret", "Robot 1", "Robot 2", "Drone", "Medic Drone", "Brain Robot", "Heavy Brain Robot" }; --feel free to edit
	self.infectionActive = 1;
	self.incubationPeriod = 1000;
	self.harmPeriod = 80;
	self.airRange = 90;
	for actor in MovableMan.Actors do
		if actor.isInfected ~= 1 then
			actor.isInfected = 0;
		end;
		local isRobot = 0;
		for i=1, #self.robotsList do
			if actor.PresetName == self.robotsList[i] then
				isRobot = 1;
			end
		end
		if isRobot == 0 and (actor.ClassName == "ACrab" or actor.ClassName == "AHuman") then
			local distance = math.sqrt((actor.Pos.X - self.Pos.X) ^ 2 + (actor.Pos.Y - self.Pos.Y) ^ 2);
			if distance <= self.airRange*2 and actor.isInfected ~= 1 then
				actor.isInfected = 1;
				print(actor.PresetName .. " IS INFECTED = " .. actor.isInfected);	
				actor.isInIncubation = 0;
				actor.infectionTimer = Timer();
				actor.lastHealth = actor.Health;
			end
		end
	end
	if infectionManaged == 1 then
		self:GibThis(); --means just one Infection Origin particle stays in game at any time
	end
	infectionManaged = 1;
end

function Update(self)
	print("UPDATING");
	if self.infectionActive == 1 then
		self.infectedCount = 0;
		for actor in MovableMan.Actors do
			if actor.isInfected ~= 1 then
				actor.isInfected = 0;
			end;
			if actor.ClassName == "AHuman" then
				print(actor.PresetName .. " IS INFECTED = " .. actor.isInfected);
			end
			if actor.isInfected == 1 then
				print(actor.PresetName .. " IS STILL INFECTED");
				self.infectedCount = self.infectedCount + 1;
				for actor in MovableMan.Actors do
					local isRobot = 0;
					for i=1, #self.robotsList do
						if actor.PresetName == self.robotsList[i] then
							isRobot = 1;
						end
					end
					if isRobot == 0 and (actor.ClassName == "ACrab" or actor.ClassName == "AHuman") then
						local distance = math.sqrt((actor.Pos.X - self.Pos.X) ^ 2 + (actor.Pos.Y - self.Pos.Y) ^ 2);
						if distance <= self.airRange and actor.isInfected ~= 1 then
							actor.isInfected = 1;
							actor.isInIncubation = 1;
							print(actor.PresetName .. " IS INFECTED");
							actor.infectionTimer = Timer();
							actor.lastHealth = infected.Health;
						end
					end
				end
				if infected.isInIncubation == 1 and infected.infectionTimer:IsPastSimMS(self.incubationPeriod) then
					print(infected.PresetName .. "'s INFECTION STARTS TO SHOW");
					infected.isInIncubation = 0;
					infected.infectionTimer = Timer();
				end
				if infected.isInIncubation == 0 and infected.infectionTimer:IsPastSimMS(self.harmPeriod) then
					infected.Health = infected.Health - 1;
					infected.infectionTimer = Timer();
				end
				if infected.Health == 100 and infected.lastHealth < 100 then
					print(infected.PresetName .. " IS CURED");
					infected.isInfected = 0;
				end
				infected.lastHealth = infected.Health;
			end
		end
		if self.infectedCount == 0 then
			infectionManaged = 0; --if there's no one infected Infection Origin particle dissapears
			self.infectionActive = 0;		
			self:GibThis();
			print("INFECTION STOPPED");
		end
	end
end
